﻿#region The MIT License - Copyright (C) 2012-2013 Pieter Geerkens
/////////////////////////////////////////////////////////////////////////////////////////
//                PG Software Solutions Inc. - Hex-Grid Utilities
/////////////////////////////////////////////////////////////////////////////////////////
// The MIT License:
// ----------------
// 
// Copyright (c) 2012-2013 Pieter Geerkens (email: pgeerkens@hotmail.com)
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of this
// software and associated documentation files (the "Software"), to deal in the Software
// without restriction, including without limitation the rights to use, copy, modify, 
// merge, publish, distribute, sublicense, and/or sell copies of the Software, and to 
// permit persons to whom the Software is furnished to do so, subject to the following 
// conditions:
//     The above copyright notice and this permission notice shall be 
//     included in all copies or substantial portions of the Software.
// 
//     THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//     EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
//     OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
//     NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
//     HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
//     WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//     FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
//     OTHER DEALINGS IN THE SOFTWARE.
/////////////////////////////////////////////////////////////////////////////////////////
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PGNapoleonics.HexgridPanel {
/// @mainpage HexgridUtilities V 6.3
/// 
/// @section Introduction 
/// 
/// <b>PGNapoleonics.HexgridUtilities</b> is a library of utilities and controls for buillding strategy simulation games on hexagonal-grid 
/// mapboards.
/// 
/// @subsection Detailed_Description Detailed Description
///
/// - <b>PGNapoleonics</b> is the top level namespace for software develoepd by <b>PGSoftware Solutions Inc.</b>,
/// and comprises these subsidiary namespaces:
///   + <b>HexgridExample2</b> is a sample <b>WinForms</b> application demonstrating some straight-forward usage of the library.
///   + <b>HexgridPanel</b> is the <b>System.Windows.Forms</b> specific extensions to support hex-grid panels in <b>Winforms</b> applications.
///   + <b>HexUtilities</b> is the display-technology independent utilities underpinnign the provision of hex-grid utilities.
///   + <b>WinForms</b> is a collection of extensions to the <b>System.Windows.Forms</b> technologies used by the remainder of the library.
/// 
/// @subsection Getting_Started Getting Started
///
/// To get started, explore how the two sample maps in HexgridExample2 override
/// the base class MapDisplay<THex>, and how the sample form overrides the base control HexgridPanel. 
/// 
/// The Collaboration diagram for MapDisplay<THex> provides a good overview of the library structure.
/// 
/// @subsection Authorship 
/// 
/// Brought to you by <b>PG Software Solutions Inc.</b>, a quality software provider.
/// 
/// Our software are more than <b>Pretty Good Solutions</b>; ... they're <b>Pretty Great Solutions!</b>
/// 
/// @subsection The_MIT_License The MIT License:
/// 
/// @copyright &copy; 2012-2013 Pieter Geerkens (email: pgeerkens@hotmail.com)
/// 
/// > Permission is hereby granted, free of charge, to any person obtaining a copy of this  
/// > software and associated documentation files (the "Software"), to deal in the Software  
/// > without restriction, including without limitation the rights to use, copy, modify,  
/// > merge, publish, distribute, sublicense, and/or sell copies of the Software, and to  
/// > permit persons to whom the Software is furnished to do so, subject to the following  
/// > conditions:
/// >
/// >     The above copyright notice and this permission notice shall be 
/// >     included in all copies or substantial portions of the Software.
/// >
/// >     THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
/// >     EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
/// >     OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
/// >     NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
/// >     HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
/// >     WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
/// >     FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
/// >     OTHER DEALINGS IN THE SOFTWARE.
//////////////////////////////////////////////////////////////////////////////////////////
}
